# Currently deployed on stretch
image: debian:stretch

variables:
  USER: lookup
  PACKAGE: flask-lookup
  PACKAGE_TARGET: root@get.phy.cam.ac.uk:/var/www/get.phy/python/packages/

stages:
  - build
  - test
  - deploy

build:wheel:
  stage: build
  image: python:3.7
  script:
    - python --version
    - pip wheel --no-deps "${CI_PROJECT_DIR}" -w "${CI_PROJECT_DIR}/${PACKAGE}/"
  artifacts:
    paths:
      - ${CI_PROJECT_DIR}/${PACKAGE}/*.whl

test:pytest36:
  stage: test
  image: python:3.6
  before_script:
    - apt-get update -qq
    - apt-get install -y -qq postgresql
    # Use a non-root user as postgres testing fails with root
    - useradd -ms /bin/bash ${USER}
  script:
    - python --version
    - pip install "${CI_PROJECT_DIR}"[test]
    - su -c "pytest --junit-xml=${CI_PROJECT_DIR}/pytest.xml ${CI_PROJECT_DIR}" ${USER}
  artifacts:
    reports:
      junit: pytest.xml

test:pytest37:
  stage: test
  image: python:3.7
  before_script:
    - apt-get update -qq
    - apt-get install -y -qq postgresql
    # Use a non-root user as postgres testing fails with root
    - useradd -ms /bin/bash ${USER}
  script:
    - python --version
    - pip install "${CI_PROJECT_DIR}"[test]
    - su -c "pytest --junit-xml=${CI_PROJECT_DIR}/pytest.xml ${CI_PROJECT_DIR}" ${USER}
  artifacts:
    reports:
      junit: pytest.xml

deploy:get-phy:
  stage: deploy
  image: alpine
  before_script:
    - apk add --no-cache openssh-client bash rsync
  script:
    # deployment info (only available in master)
    - eval $(ssh-agent)
    - bash -c 'ssh-add <(echo "${SSH_DEPLOY_KEY}") > /dev/null'
    - mkdir -p "${HOME}/.ssh"
    - echo "StrictHostKeyChecking no" >> "${HOME}/.ssh/config"
    # artifact from previous stage
    - rsync -av "${PACKAGE}" "${PACKAGE_TARGET}"
  only:
    refs:
        - master
    variables:
        - $CI_PROJECT_URL =~ /https:\/\/codeshare.phy.cam.ac.uk\/.*/
